InfinitelyAmbiguousSymbolList (BioJava-1.5-beta API)
Keywords: org.biojavax.bio.seq.InfinitelyAmbiguousSymbolList class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.biojavax.bio.seq
Class InfinitelyAmbiguousSymbolList

    java.lang.Object
      org.biojavax.bio.seq.InfinitelyAmbiguousSymbolList

All Implemented Interfaces:
  SymbolList, Changeable

    public class InfinitelyAmbiguousSymbolList

extends Object
implements SymbolList

A symbol list that is `Integer.MAX_VALUE`long, never gives index out of bounds and always returns ambiguity symbols for everything.

Since:
  1.5
Author:
  Richard Holland, MarkSchreiber

Field Summary

Fields inherited from interface org.biojava.bio.symbol.SymbolList
`EDIT, EMPTY_LIST`

Constructor Summary
`InfinitelyAmbiguousSymbolList(FiniteAlphabet fa)` Creates a new instance of InfinitelyAmbiguousSymbolList

Method Summary
`void` | `addChangeListener(ChangeListener cl)` Add a listener that will be informed of all changes. IGNORED
`void` | `addChangeListener(ChangeListener cl, ChangeType ct)` Add a listener that will be informed of changes of a given type. IGNORED
`void` | `edit(Edit edit)` Apply an edit to the SymbolList as specified by the edit object. IGNORED
`Alphabet` | `getAlphabet()` The alphabet that this SymbolList is over.
`boolean` | `isUnchanging(ChangeType ct)` A particular ChangeType can never be raised by this Changeable. ALWAYS RETURNS TRUE
`Iterator` | `iterator()` An Iterator over all Symbols in this SymbolList. ALWAYS RETURNS AN ITERATOR OVER A SINGLE AMBIGUITY SYMBOL
`int` | `length()` The number of symbols in this SymbolList. ALWAYS RETURNS `Integer.MAX_VALUE`
`void` | `removeChangeListener(ChangeListener cl)` Remove a listener that was interested in all types of changes. IGNORED
`void` | `removeChangeListener(ChangeListener cl, ChangeType ct)` Remove a listener that was interested in a specific types of changes. IGNORED
`String` | `seqString()` Stringify this symbol list. ALWAYS RETURNS THE AMBIGUITY SYMBOL REPRESENTED AS A STRING
`SymbolList` | `subList(int start, int end)` Return a new SymbolList for the symbols start to end inclusive. ALWAYS RETURNS SELF
`String` | `subStr(int start, int end)` Return a region of this symbol list as a String. ALWAYS RETURNS THE CORRECT LENGTH STRING MADE UP OF AMBIGUITY SYMBOLS
`Symbol` | `symbolAt(int index)` Return the symbol at index, counting from 1. ALWAYS RETURNS THE AMBIGUITY SYMBOL
`List` | `toList()` Returns a List of symbols. ALWAYS RETURNS A LIST CONTAINING THE AMBIGUITY SYMBOL

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### InfinitelyAmbiguousSymbolList

    public InfinitelyAmbiguousSymbolList(FiniteAlphabet fa)

  Creates a new instance of InfinitelyAmbiguousSymbolList

  Parameters:
    `fa` - the finite alphabet to return ambiguous symbols from.

Method Detail

### addChangeListener

    public void addChangeListener(ChangeListener cl)

  Add a listener that will be informed of all changes. IGNORED

  Specified by:
    `addChangeListener` in interface `Changeable`
  Parameters:
    `cl` - the ChangeListener to add

### addChangeListener

    public void addChangeListener(ChangeListener cl,
                                  ChangeType ct)

  Add a listener that will be informed of changes of a given type. IGNORED

  Specified by:
    `addChangeListener` in interface `Changeable`
  Parameters:
    `cl` - the ChangeListener
    `ct` - the ChangeType it is to be informed of

### edit

    public void edit(Edit edit)
              throws IndexOutOfBoundsException,
                     IllegalAlphabetException,
                     ChangeVetoException

  Apply an edit to the SymbolList as specified by the edit object.

  ## Description

  All edits can be broken down into a series of operations that change contiguous blocks of the sequence. This represent a one of those operations.

  When applied, this Edit will replace 'length' number of symbols starting a position 'pos' by the SymbolList 'replacement'. This allow to do insertions (length=0), deletions (replacement=SymbolList.EMPTY_LIST) and replacements (length>=1 and replacement.length()>=1).

  The pos and pos+length should always be valid positions on the SymbolList to:

  - be edited (between 0 and symL.length()+1).
  - To append to a sequence, pos=symL.length()+1, pos=0.
  - To insert something at the beginning of the sequence, set pos=1 and length=0.

  ## Examples

  `

       SymbolList seq = DNATools.createDNA("atcaaaaacgctagc");
       System.out.println(seq.seqString());

       // delete 5 bases from position 4
       Edit ed = new Edit(4, 5, SymbolList.EMPTY_LIST);
       seq.edit(ed);
       System.out.println(seq.seqString());

       // delete one base from the start
       ed = new Edit(1, 1, SymbolList.EMPTY_LIST);
       seq.edit(ed);

       // delete one base from the end
       ed = new Edit(seq.length(), 1, SymbolList.EMPTY_LIST);
       seq.edit(ed);
       System.out.println(seq.seqString());

       // overwrite 2 bases from position 3 with "tt"
       ed = new Edit(3, 2, DNATools.createDNA("tt"));
       seq.edit(ed);
       System.out.println(seq.seqString());

       // add 6 bases to the start
       ed = new Edit(1, 0, DNATools.createDNA("aattgg");
       seq.edit(ed);
       System.out.println(seq.seqString());

       // add 4 bases to the end
       ed = new Edit(seq.length() + 1, 0, DNATools.createDNA("tttt"));
       seq.edit(ed);
       System.out.println(seq.seqString());

       // full edit
       ed = new Edit(3, 2, DNATools.createDNA("aatagaa");
       seq.edit(ed);
       System.out.println(seq.seqString());

  ` IGNORED

  Specified by:
    `edit` in interface `SymbolList`
  Parameters:
    `edit` - the Edit to perform
  Throws:
    `IndexOutOfBoundsException` - if the edit does not lie within the SymbolList
    `IllegalAlphabetException` - if the SymbolList to insert has an incompatible alphabet
    `ChangeVetoException` - if either the SymboList does not support the edit, or if the change was vetoed

### getAlphabet

    public Alphabet getAlphabet()

  The alphabet that this SymbolList is over.

  Every symbol within this SymbolList is a member of this alphabet. `alphabet.contains(symbol) == true` for each symbol that is within this sequence.

  Specified by:
    `getAlphabet` in interface `SymbolList`
  Returns:
    the alphabet

### isUnchanging

    public boolean isUnchanging(ChangeType ct)

  A particular ChangeType can never be raised by this Changeable.

  If this returns true, then it is guaranteed that change events of this type (and all child types) can never under any circumstances be fired by this Changeable instance. If it returns false, that does not mean that this type of event will or even can be raised, but that it is worth registering listeners incase.

  ALWAYS RETURNS TRUE

  Specified by:
    `isUnchanging` in interface `Changeable`
  Parameters:
    `ct` - the ChangeType to check
  Returns:
    true if ChangeEvents of this type are guaranteed to never be fired

### iterator

    public Iterator iterator()

  An Iterator over all Symbols in this SymbolList.

  This is an ordered iterator over the Symbols. It cannot be used to edit the underlying symbols. ALWAYS RETURNS AN ITERATOR OVER A SINGLE AMBIGUITY SYMBOL

  Specified by:
    `iterator` in interface `SymbolList`
  Returns:
    an iterator

### length

    public int length()

  The number of symbols in this SymbolList. ALWAYS RETURNS `Integer.MAX_VALUE`

  Specified by:
    `length` in interface `SymbolList`
  Returns:
    the length

### removeChangeListener

    public void removeChangeListener(ChangeListener cl)

  Remove a listener that was interested in all types of changes. IGNORED

  Specified by:
    `removeChangeListener` in interface `Changeable`
  Parameters:
    `cl` - a ChangeListener to remove

### removeChangeListener

    public void removeChangeListener(ChangeListener cl,
                                     ChangeType ct)

  Remove a listener that was interested in a specific types of changes. IGNORED

  Specified by:
    `removeChangeListener` in interface `Changeable`
  Parameters:
    `cl` - a ChangeListener to remove
    `ct` - the ChangeType that it was interested in

### seqString

    public String seqString()

  Stringify this symbol list.

  It is expected that this will use the symbol's token to render each symbol. It should be parsable back into a SymbolList using the default token parser for this alphabet. ALWAYS RETURNS THE AMBIGUITY SYMBOL REPRESENTED AS A STRING

  Specified by:
    `seqString` in interface `SymbolList`
  Returns:
    a string representation of the symbol list

### subList

    public SymbolList subList(int start,
                              int end)
                       throws IndexOutOfBoundsException

  Return a new SymbolList for the symbols start to end inclusive.

  The resulting SymbolList will count from 1 to (end-start + 1) inclusive, and refer to the symbols start to end of the original sequence. ALWAYS RETURNS SELF

  Specified by:
    `subList` in interface `SymbolList`
  Parameters:
    `start` - the first symbol of the new SymbolList
    `end` - the last symbol (inclusive) of the new SymbolList
  Throws:
    `IndexOutOfBoundsException`

### subStr

    public String subStr(int start,
                         int end)
                  throws IndexOutOfBoundsException

  Return a region of this symbol list as a String.

  This should use the same rules as seqString. ALWAYS RETURNS THE CORRECT LENGTH STRING MADE UP OF AMBIGUITY SYMBOLS

  Specified by:
    `subStr` in interface `SymbolList`
  Parameters:
    `start` - the first symbol to include
    `end` - the last symbol to include
  Returns:
    the string representation
  Throws:
    `IndexOutOfBoundsException` - if either start or end are not within the SymbolList

### symbolAt

    public Symbol symbolAt(int index)
                    throws IndexOutOfBoundsException

  Return the symbol at index, counting from 1. ALWAYS RETURNS THE AMBIGUITY SYMBOL

  Specified by:
    `symbolAt` in interface `SymbolList`
  Parameters:
    `index` - the offset into this SymbolList
  Returns:
    the Symbol at that index
  Throws:
    `IndexOutOfBoundsException` - if index is less than 1, or greater than the length of the symbol list

### toList

    public List toList()

  Returns a List of symbols.

  This is an immutable list of symbols. Do not edit it. ALWAYS RETURNS A LIST CONTAINING THE AMBIGUITY SYMBOL

  Specified by:
    `toList` in interface `SymbolList`
  Returns:
    a List of Symbols

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD